{ SMReport Designer

  Copyright (C) 1998-2002, written by Mike Shkolnik, Scalabium
  FIDOnet: 2:463/106.14
  E-Mail:  smreport@scalabium.com
           mshkolnik@scalabium.com
           mshkolnik@yahoo.com
  WEB: http://www.scalabium.com
       http://www.geocities.com/mshkolnik
  tel: 380-/44/-552-10-29

  In this unit I create a TSMRChart component for
  demonstation of technology for custom control creation
  in SMReport Designer.
}
unit SMRChart;

interface

uses
  Windows, Classes, graphics, StdCtrls, Controls,
  DB, SMRBase, DBChart;

const
  {range for custom constants is:
   for lnEnglish - 12500..12999
   for lnRussian - 14500..14999
   for lnUkrainian - 16500..16999
   for lnGerman - 18500..18999
   for lnFrance - 20500..20999
   for lnSpanish - 22500..22999
   for lnItalian - 24500..24999
   for lnPortuguese - 26500..26999
  }
  smrcNewChart = 5010;
  smrcDesignerBtnChart = 5011;

type
  { chart on the band }
  TSMRChart = class(TSMRControl)
  private
    { Private declarations }
    FChart: TCustomDBChart;
  protected
    { Protected declarations }
  public
    { Public declarations }
    constructor Create(AOwner: TComponent); override;
    destructor Destroy; override;
    function Draw(ACanvas: TCanvas; var ARect: TRect; intBandHeight: Integer; Flags: Word): Integer; override;
    function EditProperties(ShowPrevForm: Boolean): Boolean; override;
  published
    { Published declarations }
    property Chart: TCustomDBChart read FChart write FChart;
  end;


implementation
{$R *.RES}
uses SMRCnst, SMRUtils, EditChar, DBEditCh, Forms;

var
  frmChartParent: TForm;

{ TSMRChart }
constructor TSMRChart.Create(AOwner: TComponent);
begin
  inherited Create(AOwner);

  FChart := TCustomDBChart.Create(nil);
  FChart.Parent := frmChartParent;
  FChart.Title.Text.Clear;
  FChart.Title.Text.Add('Chart');
  FChart.BufferedDisplay := False;
  DisplayName := GetString(FSMReport.GetLanguageShift, smrcNewChart);
end;

destructor TSMRChart.Destroy;
begin
  FChart.Free;

  inherited Destroy;
end;

function TSMRChart.Draw(ACanvas: TCanvas; var ARect: TRect; intBandHeight: Integer; Flags: Word): Integer;
//var intChartWidth, intChartHeight: Integer;
//    Meta: TMetaFile;
begin
  Result := inherited Draw(ACanvas, ARect, intBandHeight, Flags);

  if (Flags and DT_CALCRECT <> 0) then Exit;

{  Meta := FChart.TeeCreateMetafile(False, Rect(0, 0, intChartWidth, intChartHeight));
  try
    ACanvas.StretchDraw(ARect, Meta);
  finally
    Meta.Free;
  end;
}  FChart.DrawToMetaCanvas(ACanvas, ARect);
end;

function TSMRChart.EditProperties(ShowPrevForm: Boolean): Boolean;
begin
  Result := inherited EditProperties(False);

  if ShowPrevForm then
  begin
    FChart.Title.Alignment := Alignment;
    FChart.Title.Font.Assign(Font);
    FChart.Color := BackColor;

    EditChart(nil, FChart);
//    EditDBChart(nil, FChart);

    Alignment := FChart.Title.Alignment;
    Font.Assign(FChart.Title.Font);
    BackColor := FChart.Color;

  end;
end;



initialization
  frmChartParent := TForm.Create(nil);
  RegisterSMRControl(TSMRChart, smrcDesignerBtnChart, '', hInstance);

finalization
  frmChartParent.Free;
  UnRegisterSMRControl(TSMRChart);

end.
